package com.scand.svgsource;

import android.graphics.Bitmap;
import android.os.AsyncTask;
import android.os.Environment;
import android.support.v7.app.ActionBarActivity;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuItem;
import android.widget.ImageView;

import com.scand.svg.parser.SVGHelper;

import java.io.File;
import java.io.IOException;
import java.net.MalformedURLException;
import java.net.URL;


public class MainActivity extends ActionBarActivity {

    private ImageView mImageViewUrl;
    private ImageView mImageViewRaw;
    private ImageView mImageViewFile;
    private ImageView mImageViewString;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        mImageViewRaw = (ImageView)findViewById(R.id.svg_from_url);
        mImageViewUrl = (ImageView)findViewById(R.id.svg_from_raw);
        mImageViewFile = (ImageView)findViewById(R.id.svg_from_file);
        mImageViewString = (ImageView)findViewById(R.id.svg_from_string);

        LoadFromUrlTask loadFromUrlTask = new LoadFromUrlTask();
        loadFromUrlTask.execute("http://dev.w3.org/SVG/tools/svgweb/samples/svg-files/star.svg");

        try {
            Bitmap svgRaw = SVGHelper.useContext(this).open(R.raw.star).checkSVGSize().getBitmap();
            mImageViewRaw.setImageBitmap(svgRaw);

            String path = Environment.getExternalStorageDirectory()+ "/svg/star.svg";
            File file =new File(path);
            Bitmap svgFile = SVGHelper.noContext().open(file).checkSVGSize().getBitmap();
            mImageViewFile.setImageBitmap(svgFile);

            String svgStarStr="<svg xmlns=\"http://www.w3.org/2000/svg\" viewBox=\"0 0 100 100\">\n" +
                    "<path d=\"M50,3l12,36h38l-30,22l11,36l-31-21l-31,21l11-36l-30-22h38z\"\n" +
                    "fill=\"#FF0\" stroke=\"#FC0\" stroke-width=\"2\"/>\n" +
                    "</svg>\n";

            Bitmap svgStar = SVGHelper.noContext().open(svgStarStr).checkSVGSize().getBitmap();
            mImageViewString.setImageBitmap(svgStar);

        } catch (IOException e) {
            e.printStackTrace();
        }

    }

    class LoadFromUrlTask extends AsyncTask<String, Void, Bitmap> {

        protected Bitmap doInBackground(String... urls) {

            URL url= null;
            try {
                url = new URL(urls[0]);
                Bitmap svg = SVGHelper.noContext().open(url).checkSVGSize().getBitmap();
                return svg;
            } catch (IOException e) {
                e.printStackTrace();
            }
            return null;
        }

        protected void onPostExecute(Bitmap svg) {
            mImageViewUrl.setImageBitmap(svg);
        }
    }

}
